This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 1025694 - pcp pmda shared libraries should use -fvisibility=hidden
pcp pmda shared libraries should use -fvisibility=hidden
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: pcp (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Nathan Scott
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-11-01 06:12 EDT by Frank Ch. Eigler
Modified: 2014-03-18 21:23 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-03-18 21:23:49 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Frank Ch. Eigler 2013-11-01 06:12:37 EDT
It is undesirable for so many symbols to show up in "nm -D fooPMDA.so".
Only shared-library imported and exported ones should.  It would be
a larger effort to similarly clean up the main PMAPI DSO's, but
worthwhile.
Comment 1 Nathan Scott 2013-11-11 00:00:21 EST
Struggling to find docs on this gcc option.  There is only one symbol the DSO PMDAs need to export, I *think* - the xxx_init function that pmcd/dbpmda/libpcp-local-context calls initially.  Everything else is called-by-function-pointer.  So we should instead restrict 'em to just that one symbol.

Quick test of the gcc option mentioned here suggests nothing at all is exported, and shared library PMDAs would be broken by it...

Log for pmcd on smash started Mon Nov 11 15:52:53 2013

Couldn't find init function `mmv_init' in mmv DSO

...


An alternative may be getting -Wl,--version-script,xxx into *all* the pcp shared libraries - including the PMDAs.  It could be generated as part of the build for shared library PMDAs, and would be good to have for libpcp and libpcp_pmda I think (may force us to begin more disciplined soname use, AIUI - not sure tho).

Thoughts?
Comment 2 Nathan Scott 2013-11-11 17:46:14 EST
| ... may force us to begin more disciplined soname use.

On closer inspection, no, doesn't help - the ABI version numbers from a versions-script file doesn't relate to soname version in any way (AFAICT).
Comment 3 Nathan Scott 2013-12-02 22:39:44 EST
Wider issues now understood, this issue is tackled in upstream git commit de90a013.
Comment 4 Fedora Update System 2013-12-12 01:55:13 EST
pcp-3.8.9-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/pcp-3.8.9-1.fc20
Comment 5 Fedora Update System 2013-12-12 01:55:56 EST
pcp-3.8.9-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/pcp-3.8.9-1.fc19
Comment 6 Fedora Update System 2013-12-12 01:56:39 EST
pcp-3.8.9-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/pcp-3.8.9-1.fc18
Comment 7 Fedora Update System 2013-12-12 01:57:32 EST
pcp-3.8.9-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/pcp-3.8.9-1.el6
Comment 8 Fedora Update System 2013-12-12 01:58:13 EST
pcp-3.8.9-1.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/pcp-3.8.9-1.el5
Comment 9 Fedora Update System 2014-01-06 20:21:39 EST
pcp-3.8.9-1.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 10 Fedora Update System 2014-01-06 20:23:47 EST
pcp-3.8.9-1.el6 has been pushed to the Fedora EPEL 6 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 11 Fedora Update System 2014-01-07 04:45:52 EST
pcp-3.8.9-1.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 12 Fedora Update System 2014-01-07 04:46:51 EST
pcp-3.8.9-1.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 13 Fedora Update System 2014-01-07 04:50:00 EST
pcp-3.8.9-1.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.